#include <Debug.h>

#include "DEV_Config.h"
#include "Waveshare_AS7341.h"


int Data[10], Phon[10];

byte Prefix = 1;
float Norm[] = {0.102468349, 1, 0.485654431, 0.549594681, 0.672556699, 0.597686492, 0.468439749, 0.254850169, 0.075720315  };
float R[9];

int LED_Brighness = 0;
byte i;

#include <Servo.h>

Servo myservo[6];

byte Pos[6];
int TimeOfDelay = 150;
byte Mode, OldMode;

void ModeOn(void);
void Pearson(void);


int Colors[6][8] = {970, 2261, 3362, 8549, 16549, 16906, 12609, 6073, 151, 1182, 778, 870, 1397, 1894, 1544, 721, 1002, 11144, 7398, 6922, 9341, 8117, 6324, 3398, 218,717,553,566,856,3106,5465,2706,158,1034,1114,2594,1794,823,533,289, 374,6267,3860,1957,1207,838,709,501,};
float Prs[6];

//byte Txt[5][5]={

void setup() {

  //pinMode(4, INPUT_PULLUP);
  Serial.begin(115200);

  DEV_ModuleInit();
  Serial.print("   Robo Pike 07 Six Servs AS7341    IIC ready! Now start initializing AS7341!\r\n");
  AS7341_Init(eSpm);
  AS7341_ATIME_config(100);// 100
  AS7341_ASTEP_config(999);
  AS7341_AGAIN_config(6);
  AS7341_EnableLED(true);// LED Enable

  for (byte jj = 0; jj < 9; jj++)
    Norm[jj] = Norm[jj] * 32937;

  for (  i = 0; i < 6; i++)
  {
    myservo[i].attach(2 + i);
    Pos[i] = 90;
  }
}

void loop() {

  ModeOn();
//  if (Mode++ > 8)
//    Mode = 0;










  //if (digitalRead(4) == LOW)
  //Prefix=2;
  //else
  //Prefix=0;

  AS7341_ControlLed(LED_Brighness, 4);

  LED_Brighness ^= 1;

  delay(100);
  //  if(LED_Brighness >0)
  //  AS7341_ControlLed(true,LED_Brighness);//Turn on or off the LED and set the brightness of the LED
  //  else
  //  AS7341_ControlLed(false,0);
  //
  //Serial.print(LED_Brighness);
  //
  //if (++LED_Brighness>20)
  //LED_Brighness=0;


  sModeOneData_t data1;
  sModeTwoData_t data2;

  AS7341_startMeasure(eF1F4ClearNIR);
  data1 = AS7341_ReadSpectralDataOne();

  R[0] = data1.channel1 / Norm[0];
  R[1] = data1.channel2 / Norm[1];
  R[2] = data1.channel3 / Norm[2];
  R[3] = data1.channel4 / Norm[3];
  AS7341_startMeasure(eF5F8ClearNIR);
  data2 = AS7341_ReadSpectralDataTwo();
  R[4] = data2.channel5 / Norm[4];
  R[5] = data2.channel6 / Norm[5];
  R[6] = data2.channel7 / Norm[6];
  R[7] = data2.channel8 / Norm[7];
  R[8] = data2.NIR / Norm[8];



  if (Prefix == 1)
  {
    AS7341_startMeasure(eF1F4ClearNIR);
    data1 = AS7341_ReadSpectralDataOne();
    if (LED_Brighness == 0)
    {
      Data[0] = data1.channel1 - Phon[0];
      Data[1] = data1.channel2 - Phon[1];
      Data[2] = data1.channel3 - Phon[2];
      Data[3] = data1.channel4 - Phon[3];
      Data[4] = data2.channel5 - Phon[4];
      Data[5] = data2.channel6 - Phon[5];
      Data[6] = data2.channel7 - Phon[6];
      Data[7] = data2.channel8 - Phon[7];
      Data[8] = data2.NIR - Phon[8];
      Data[9] = data2.CLEAR - Phon[9];

      Pearson();
    }
    else
    {
      Phon[0] = data1.channel1;
      Phon[1] = data1.channel2 ;
      Phon[2] = data1.channel3 ;
      Phon[3] = data1.channel4 ;
      Phon[4] = data2.channel5 ;
      Phon[5] = data2.channel6 ;
      Phon[6] = data2.channel7  ;
      Phon[7] = data2.channel8 ;
      Phon[8] = data2.NIR ;
      Phon[9] = data2.CLEAR;
    }


    if (LED_Brighness == 0)
    {
      Serial.print("(405-425nm):\t");
      //Serial.println(data1.channel1);
      Serial.println(Data[0]);
      Serial.print("(435-455nm):\t");
      //Serial.println(Data1.channel2);
      Serial.println(Data[1]);

      Serial.print("(470-490nm):\t");
      Serial.println(Data[2]);
      // Serial.println(data1.channel3);



      Serial.print("(505-525nm):\t");
      //Serial.println(data1.channel4);
      Serial.println(Data[3]);
      AS7341_startMeasure(eF5F8ClearNIR);
      data2 = AS7341_ReadSpectralDataTwo();
      Serial.print("(545-565nm):\t");
      Serial.println(Data[4]);
      //Serial.println(data2.channel5);
      Serial.print("(580-600nm):\t");
      Serial.println(Data[5]);
      //Serial.println(data2.channel6);
      Serial.print("(620-640nm):\t");
      //Serial.println(data2.channel7);
      Serial.println(Data[6]);
      Serial.print("(670-690nm):\t");
      Serial.println(Data[7]);
      //Serial.println(data2.channel8);

      //Serial.println(data2.CLEAR);
      Serial.print("NIR:\t");
      Serial.println(Data[8]);
      Serial.print("Clear:\t");
      Serial.println(Data[9]);
      Serial.print("--------------------------\r\n");
    }

  }
  else if (Prefix == 2)
  {

    AS7341_startMeasure(eF1F4ClearNIR);
    data1 = AS7341_ReadSpectralDataOne();

    Serial.print("\t");
    Serial.print(data1.channel1);
    Serial.print("\t");
    Serial.print(data1.channel2);
    Serial.print("\t");
    Serial.print(data1.channel3);
    Serial.print("\t");
    Serial.print(data1.channel4);
    AS7341_startMeasure(eF5F8ClearNIR);
    data2 = AS7341_ReadSpectralDataTwo();
    Serial.print("\t");
    Serial.print(data2.channel5);
    Serial.print("\t");
    Serial.print(data2.channel6);
    Serial.print("\t");
    Serial.print(data2.channel7);
    Serial.print("\t");
    Serial.print(data2.channel8);
    Serial.print("\t");
    Serial.print(data2.NIR);
    Serial.print("\r\n");
  }

  else if (Prefix == 0)
  {
    for (byte jj = 0; jj < 9; jj++)
    {
      Serial.print("\t");
      Serial.print(R[jj]);
    }
    Serial.println();
  }
  else if (Prefix == 3)


    if (Prefix == 3)
    {
      AS7341_startMeasure(eF1F4ClearNIR);
      data1 = AS7341_ReadSpectralDataOne();

      Serial.print("hhh");
      Serial.print(data1.channel1);
      Serial.print("\t");
      Serial.print(data1.channel2);
      Serial.print("\t");
      Serial.print(data1.channel3);
      Serial.print("\t");
      Serial.print(data1.channel4);
      AS7341_startMeasure(eF5F8ClearNIR);
      data2 = AS7341_ReadSpectralDataTwo();
      Serial.print("\t");
      Serial.print(data2.channel5);
      Serial.print("\t");
      Serial.print(data2.channel6);
      Serial.print("\t");
      Serial.print(data2.channel7);
      Serial.print("\t");
      Serial.print(data2.channel8);

      Serial.print("\t");
      Serial.println(data2.NIR);

    }

  DEV_Delay_ms(50);




}

void ModeOn(void)
{
  Serial.print ("Mode = ");
  Serial.print (Mode);
  Serial.print(" A0= ");
  Serial.println(analogRead(A0));
  switch (Mode)
  {
    case 0:

      for (i = 0; i < 6; i++)
        Pos[i] = 65 + analogRead(A0) / 20;

      Serial.print("  Pos= ");
      Serial.println(Pos[1]);

      for (i = 0; i < 6; i++)
      {
        myservo[i].write(Pos[i]);
        delay(TimeOfDelay);
      }
          Mode=1;
          OldMode=0;
      break;

    case 1:

      for (i = 0; i < 6; i++)
        Pos[i] = 90 +  2 * ( (i % 2) - 0.5) * analogRead(A0) / 40;

      //Serial.print("  Pos= ");
      //Serial.println(Pos[1]);

      for (i = 0; i < 6; i++)
      {
        myservo[i].write(Pos[i]);
        delay(TimeOfDelay);
      }

      Mode=2;
      OldMode=1;
      break;

    case 2:

      for (i = 0; i < 6; i++)
        Pos[i] = 90 -  2 * ( (i % 2) - 0.5) * analogRead(A0) / 40;

      //Serial.print("  Pos= ");
      //Serial.println(Pos[1]);

      for (i = 0; i < 6; i++)
      {
        myservo[i].write(Pos[i]);
        delay(TimeOfDelay);
      }

      Mode=0;
      OldMode=2;
      break;






case 3:

      for (i = 0; i < 6; i++)
        Pos[i] = 115 - analogRead(A0) / 20;

      Serial.print("  Pos= ");
      Serial.println(Pos[1]);

      for (i = 0; i < 6; i++)
      {
        myservo[i].write(Pos[i]);
        delay(TimeOfDelay);
      }
          Mode=1;
          OldMode=3;
      break;




    case 4:



      for (i = 0; i < 40; i++)
      {
        myservo[0].write(90 - i);
        delay(TimeOfDelay / 10);
      }

      for (i = 0; i < 80; i++)
      {
        myservo[0].write(50 + i);
        delay(TimeOfDelay / 10);
      }

      for (i = 0; i < 40; i++)
      {
        myservo[0].write(130 - i);
        delay(5);
      }
        OldMode=4;
      break;

    case 5:



      for (i = 0; i < 90; i++)
      {
        myservo[5].write(90 - i);
        delay(TimeOfDelay / 10);
      }

      for (i = 0; i < 180; i++)
      {
        myservo[5].write(i);
        delay(TimeOfDelay / 10);
      }

      for (i = 0; i < 90; i++)
      {
        myservo[5].write(180 - i);
        delay(TimeOfDelay / 10);
      }
          OldMode=5;
      break;


    case 6:

      for (int i2 = 0; i2 < 6; i2++)
      {

        for (i = 0; i < 40; i+=3)
        {
          myservo[0].write(90 - i);
          delay(TimeOfDelay / 10);
        }

        for (i = 0; i < 80; i+=3)
        {
          myservo[0].write(50 + i);
          delay(TimeOfDelay / 10);
        }

        for (i = 0; i < 40; i+=3)
        {
          myservo[0].write(130 - i);
             delay(TimeOfDelay / 10);
        }
        
      }


      OldMode=6;
      break;

case 7:

      for (int i2 = 0; i2 < 6; i2++)
      {
 
          myservo[i2].write(90 );
          delay(TimeOfDelay );
    
        
      }
      OldMode=7;
      break;


case 8:

      
      {
  
 for (i = 0; i < 6; i++)
        Pos[i] = 90 -  2 * ( (i % 2) - 0.5) * 90;

      //Serial.print("  Pos= ");
      //Serial.println(Pos[1]);

      for (i = 0; i < 6; i++)
      {
        myservo[i].write(Pos[i]);
        delay(TimeOfDelay);
      }

          delay(2000);

    
        
      }
 OldMode=8;
      break;


case 9:

      if (OldMode !=9)
      {
 
           
 int Fi=5;
for(Fi=0;Fi<15;Fi++)
 {
      for (i=0;i<6;i++)
    Pos[i]=90+Fi+Fi*i;
    

      for (i = 0; i < 6; i++)
      {
        myservo[5-i].write(Pos[i]);
        delay(TimeOfDelay);
      }

 }
          
          delay(2000);

    
        
      }
 OldMode=9;
      break;










  }


}


void Pearson(void)
{
 // Serial.println("Pearson!! Now!");
float Sxy, Sx, Sy, Sx2, Sy2;
  int n = 8;
/*
Data [0]= 151;
Data [1]= 1182;
Data [2]= 778;
Data [3]= 870;
Data [4]= 1397;
Data [5]= 1894;
Data [6]= 1544;
Data [7]= 721;

*/





  
  for (byte t = 0; t < 6; t++) // Set by patterns
  {
    Sx=0;
    Sy=0;
    Sxy=0;
    Sx2=0;
    Sy2=0;
    for (i = 0; i < 8; i++)
    {
      Sxy=Sxy+float(Colors[t][i])*float(Data[i]);
      Sx=Sx+float(Colors[t][i]);
      Sy=Sy+float(Data[i]);
      Sx2=Sx2+float(Colors[t][i])*float(Colors[t][i]);
      Sy2=Sy2+ float(Data[i])*float(Data[i]);
/*
      Sxy = Sxy + float(Colors[t][i]) * float (Colors[t][i]);
      Sx = Sx + float(Colors[t][i]);
      Sy = Sy + float(Colors[t][i]);
      Sx2 = Sx2 + float(Colors[t][i]) * float(Colors[t][i]);
      Sy2 = Sy2 + float(Colors[t][i]) * float(Colors[t][i]);

  */      
//  Serial.print(Sxy);
//          Serial.print("\t");
    }

//    Serial.println("");
//    Serial.print("Sx \t");
//    Serial.print(Sx);
//
//    Serial.print("\tSy \t");
//    Serial.print(Sy);
//
//    Serial.print("\tSxy \t");
//    Serial.print(Sxy);
//
//    Serial.print("\tSx2 \t");
//    Serial.print(Sx2);
//
//    Serial.print("\tSy2 \t");
//    Serial.println(Sy2);
//
//
//Serial.print("\tchisl \t");
//    Serial.print(n * Sxy - Sx * Sy);
//    Serial.print("\troot0 \t");
//    Serial.print( (n * Sx2 - Sx * Sx));
//    Serial.print("\troot1 \t");
//    Serial.println( (n * Sy2 - Sy * Sy));


    Prs[t] = float((n * Sxy - Sx * Sy) )/   float (sqrt(n * Sx2 - Sx * Sx) * sqrt(n * Sy2 - Sy * Sy));

    switch (t)
    {
      case 0:
      Serial.print("GOLD ");
      break;
      case 1:
      Serial.print("BROWN ");
      break;
      case 2:
      Serial.print("WHITE ");
      break;
      
           case 4:
           Serial.print("GREEN ");
      break;
      
      case 5:
      Serial.print("BLUE ");
      break;
      
      case 3:
      Serial.print("RED ");
      break;

      
    }
    //Serial.print(" Prsn");

    //OldMode=Mode;
    Serial.print(t);
    Serial.print (" = ");
    Serial.println(Prs[t]);
    if (Prs[0]>0.9)
      Mode = 6;
      else if (  Prs[1]>0.9)
        Mode = 8;
        else if (Prs[3]>0.92)
        Mode =9;
    else 
       Mode = 7;

  }
}
